#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    cin>>n;
    int a[n], asort[n];
    for(int i=0; i<n; i++)
    {
        cin>>a[i];
        asort[i]=a[i];
    }
    sort(asort, asort+n);
    int c=0;
    vector<pair<int, int>> p;
    for(int i=0; i<n; i++)
    {
        if(a[i]!=asort[i])
        {
            c++;
            for(int j=i+1; j<n; j++)
            {
                if(a[j]==asort[i])
                {
                    reverse(a+i, a+j+1);
                    p.push_back({i+1, j+1});
                    break;
                }
            }
        }
    }
    cout<<c<<'\n';
    for(auto i : p) cout<<i.first<<' '<<i.second<<'\n';
    return 0;
}
